﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TheTravelingSalesman_sTask
{
    internal class Decision
    {
        string path;
        public Decision(string path )
        {
            this.path = path;
        }
        private List<List<double>> Reading()
        {
            int n = File.ReadAllLines(path).Length;
            List<List<double>> table = new List<List<double>>(); ;
            using (StreamReader reader = new StreamReader(path))
            {
                for (int i = 0; i < n; i++)
                {
                    table.Add(new List<double>());
                    string text = reader.ReadLine();
                    string[] mas = text.Split(new char[] { ',' });
                    
                    for (int j = 0; j < mas.Length; j++)
                    {
                        if (mas[j] == "M")
                            table[i].Add(Double.MaxValue);
                        
                        else
                            table[i].Add(double.Parse(mas[j]));
                    }
                    

                }

            }
            return table;
        }

        private void output(List<List<char>> Table)
        {
            for (int i = 0; i < Table.Count; i++)
            {
                for (int j = 0; j < Table[i].Count; j++)
                {
                    if (Table[i][j] == ' ')
                        continue;
                    if(j==0)
                        Console.Write("{0} -> ", Table[i][j]);
                    else
                        Console.Write("{0} ", Table[i][j]);

                }
                Console.WriteLine();
            }
            Console.WriteLine();
        }


        public void method()
        {
            List<List<char>> loop = new List<List<char>>() { { new List<char> { ' ', ' '} } };
            List<List<double>> table = Reading();
            List<List<char>> loop2;
            loop2 = MainLoop(table,loop);
            output(loop2);
        }

        private List<List<char>> MainLoop(List<List<double>> table, List<List<char>> loop)
        {
            List<char> topMin = new List<char>();
            List<List<double>> minAssessment = new List<List<double>>();

            List<double> lowerBounds = new List<double>();
            double minWay = Double.MaxValue;
            int indexMinWay;
            List<char> from = new List<char>()
            {
                'A',
                'B',
                'C',
                'D',
                'E',
                'F',
                'G',
                'H',
                'I',
                'G',
                'K',
                'L',
                'M',
                'N',
                'O',
                'P',
                'R',
                'S',
                'T',
                'U',
                'V',
                'W',
                'X',
                'Y',
                'Z'
            };
            List<char> to = new List<char>()
            {
                'A',
                'B',
                'C',
                'D',
                'E',
                'F',
                'G',
                'H',
                'I',
                'G',
                'K',
                'L',
                'M',
                'N',
                'O',
                'P',
                'R',
                'S',
                'T',
                'U',
                'V',
                'W',
                'X',
                'Y',
                'Z'
            };
            

            double h = Reduction(table);
            lowerBounds.Add(h);
            List<char> letterFromMin = new List<char>();
            List<char> letterToMin = new List<char>();
            double totalLength = 0 ;
            bool flag = true;
            int index = 0;
            while (flag)
            {
                
                List<List<double?>> zeroCells = MaxFine(table);
                double maxFine = -9;
                int maxFineColumn = -2, maxFineRow = -2;

                for (int i = 0; i < zeroCells.Count; i++)
                {
                    for (int j = 0; j < zeroCells[i].Count; j++)
                    {
                        if (zeroCells[i][j] > maxFine)
                        {
                            maxFine = (double)zeroCells[i][j];
                            maxFineRow = i;
                            maxFineColumn = j;
                        }
                    }
                }
                List<List<double>> tableWithout;
                List<List<double>> temp;
                List<char>  fromTemp;
                List<char> toTemp;
                tableWithout = Copy(table);
                tableWithout[maxFineRow][maxFineColumn] = Double.MaxValue;
                List<char> letterFromWithout = Copy(from);
                List<char> letterToWithout = Copy(to);
                double hTemp = 0;
                double hWithout = maxFine + lowerBounds.LastOrDefault();
                int fromBack, toBack;
                fromBack = from.IndexOf(to[maxFineColumn]);
                toBack = to.IndexOf(from[maxFineRow]);
                if(fromBack>=0 && toBack >= 0)
                {
                    table[fromBack][toBack] = Double.MaxValue;
                }
                table = DeleteWay(table, maxFineRow, maxFineColumn);
                char delFrom = from[maxFineRow];
                char delTo = to[maxFineColumn];
                if(hTemp  == 0)
                {
                    h = Reduction(table); 
                }
                else
                {
                    h = hTemp;
                    hTemp = 0;
                }
                double hWith = h + lowerBounds.LastOrDefault();
                if(hWith<hWithout && hWith <= minWay)
                {
                    if (hWithout < minWay)
                    {
                        minAssessment.Clear();
                        minAssessment = Copy(tableWithout);
                        minWay = hWithout;
                        topMin.Clear();
                        topMin.Add(' ');
                        topMin.Add(' ');
                        letterFromMin = Copy(letterFromWithout);
                        letterToMin = Copy(letterToWithout);
                    }

                    lowerBounds.Add(hWith);
                    from.RemoveAt(maxFineRow);
                    to.RemoveAt(maxFineColumn);
                    loop.Add(new List<char>() {delFrom, delTo});
                    totalLength = hWith;
                    

                }
                if (hWithout < hWith && hWithout <= minWay)
                {
                    if (hWith < minWay)
                    {

                        minAssessment.Clear();
                        minAssessment = Copy(table);
                        letterFromMin = Copy(from);
                        letterToMin = Copy(to);
                        letterFromMin.RemoveAt(maxFineRow);
                        letterToMin.RemoveAt(maxFineColumn);
                        minWay = hWith;
                        topMin.Clear();
                        topMin.Add(delFrom);
                        topMin.Add(delTo);
                    }

                    lowerBounds.Add(hWithout);
                    loop.Add(new List<char>() { ' ', ' ' });
                    totalLength = hWithout;

                }
                if (hWithout > minWay && hWith > minWay)
                {
                    if(hWith < hWithout)
                    {
                        temp = Copy(table);
                        indexMinWay = index;
                        toTemp = Copy(letterToMin);
                        fromTemp = Copy(letterFromMin);
                        from.RemoveAt(maxFineRow);
                        to.RemoveAt(maxFineColumn);
                        

                    }
                    else
                    {
                        temp = Copy(tableWithout);
                        indexMinWay = index;
                        toTemp = Copy(to);
                        fromTemp = Copy(from);
                    }

                    table = Copy(minAssessment);
                    minAssessment = Copy(temp);

                    letterFromMin = Copy(from);
                    letterToMin = Copy(to);
                    from = Copy(fromTemp);
                    to = Copy(toTemp);
                    hTemp = Reduction(table);
                    for (int i = lowerBounds.Count-1;i >= indexMinWay; i--)
                    {
                        lowerBounds.RemoveAt(i);
                        loop.RemoveAt(i);
                    }
                    lowerBounds.Add(minWay);
                    loop.Add(new List<char> { topMin[0], topMin[1] });

                }
                int ch = 0;
                int chRow = 0;
                int chColumn = 0;

                for(int i = 0;i < table.Count; i++)
                {
                    for(int j = 0;j< table[i].Count;j++)
                    {

                        ch++;
                        chRow = i;
                        chColumn = j;

                    }
                }

                if (ch == 1)
                {
                    flag = false;
                    loop.Add(new List<char>() { from[chRow], to[chColumn] });
                }
                index++;
                
            }
            Console.WriteLine("Общая длина пути: " + totalLength);
            return loop;

        }
        private List<char> Copy(List<char> table)
        {
            List<char> copy_table = new List<char>();
            foreach(char c in table)
            {
                copy_table.Add(c);
            }    
            
            return copy_table;
        }
        private List<List<double>> Copy(List<List<double>> table)
        {
            List<List<double>> copy_table = new List<List<double>>();
            for (int i = 0; i < table.Count; i++)
            {
                copy_table.Add(new List<double>());
                for (int j = 0; j < table[i].Count; j++)
                {
                    copy_table[i].Add(table[i][j]);
                }
            }
            return copy_table;
        }
        private List<List<double>> DeleteWay(List<List<double>> table, int row, int column)
        {
            table[column][row] = Double.MaxValue;
            table.RemoveAt(row);
            for(int i  = 0; i < table.Count; i++)
            {
                table[i].RemoveAt(column);
            }
            return table;
        }

        private double Reduction(List<List<double>> table) 
        {
            double reductionRow = 0;
            for(int i = 0; i < table.Count;i++)
            {
                double min = Double.MaxValue;
                for (int j = 0;j < table[i].Count;j++)
                {
                    if (table[i][j] < min && table[i][j]!= null)
                    {
                        min = (double)table[i][j];
                    }
                }
                for (int j = 0; j < table[i].Count; j++)
                {
                    table[i][j] = table[i][j] - min;
                }
                if (min == Double.MaxValue)
                    continue;
                else
                    reductionRow += min;
            }
            double reductionColumn = 0;
            for (int i = 0; i < table.Count; i++)
            {
                double min = Double.MaxValue;
                for (int j = 0; j < table[i].Count; j++)
                {
                    if (table[j][i] < min && table[j][i] != null)
                    {
                        min = (double)table[j][i];
                    }
                }
                for (int j = 0; j < table.Count; j++)
                {
                    table[j][i] = table[j][i] - min;
                }
                if(min == Double.MaxValue)
                    continue;
                else
                    reductionColumn += min;
            }
            return reductionRow + reductionColumn;
        }

        private List<List<double?>> MaxFine(List<List<double>> table)
        {
            List<List<double?>> zeroCells = new List<List<double?>>();
            for (int i = 0;i < table.Count; i++)
            {
                zeroCells.Add(new List<double?>());
                for (int j = 0; j < table[i].Count; j++)
                {
                    if (table[i][j] == 0)
                    {
                        double temp = Fine(table, i, j);
                        zeroCells[i].Add(temp);
                    }
                    else
                    {
                        zeroCells[i].Add(null);
                    }
                }
            }
            return zeroCells;
        }

        private double Fine(List<List<double>> table, int row, int column)
        {
            double minRow = Double.MaxValue;
            for(int i = 0; i< table.Count; i++)
            {
                if (i == column)
                    continue;
                if (table[row][i] < minRow) 
                    minRow = (double)table[row][i];
            }

            double minColumn = Double.MaxValue;
            for (int i = 0; i < table.Count; i++)
            {
                if (i == row)
                    continue;
                if (table[i][column] < minColumn)
                    minColumn = (double)table[i][column];
            }
            return minRow + minColumn;
        }

        
    }
}
